# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section         free

Summary:        Day Trader Benchmark Sample
Name:           daytrader
Version:        1.1
Release:        1jpp
Epoch:		0
Group:          Applications/Internet
License:        Apache 2.0 License
URL:            http://geronimo.apache.org/
Source0:        %{name}-%{version}.tar.gz
# svn export http://svn.apache.org/repos/asf/geronimo/daytrader/tags/1.1.0/ daytrader-1.1

#Source1:        directory-pom-1.0.4.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml

Patch0:		daytrader-web-pom_xml.patch

Vendor:         JPackage Project
Distribution:   JPackage
BuildRequires:	jpackage-utils >= 0:1.7.1
BuildRequires:  maven2 => 0:2.0.4
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  izpack
BuildRequires:  jakarta-commons-daemon
BuildRequires:  plexus-utils
BuildRequires:  slf4j

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
This package contains the benchmark sample called Day Trader.
This sample was contributed by IBM to the Apache Geronimo 
project under the ASF license to further functional and 
performance testing of Geronimo.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n %{name}-%{version}
find . -name "*.jar" -exec rm {} \;

%patch0 -b .sav

%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

for p in $(find . -name "*.pom"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

for p in $(find . -name "*pom.xml"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

#mkdir -p m2_repo/repository/JPP/maven2/default_poms
#cp %{SOURCE1} m2_repo/repository/JPP/maven2/default_poms/org.apache.directory-build.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

MVN=/usr/bin/mvn
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.mode=true -Dmaven.test.failure.ignore=true -Djava.awt.headless=true"
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 modules/ejb/target/%{name}-ejb-1.1-client.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/ejb-client-%{version}.jar
install -m 644 modules/ejb/target/%{name}-ejb-1.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/ejb-%{version}.jar
install -m 644 modules/streamer/target/%{name}-streamer-1.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/streamer-%{version}.jar
install -m 644 modules/wsappclient/target/%{name}-wsappclient-1.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/wsappclient-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# war, ear
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 modules/ear/target/%{name}-ear-1.1.ear $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-ear-%{version}.ear
install -m 644 modules/web/target/%{name}-web-1.1.war $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-web-%{version}.war
(cd $RPM_BUILD_ROOT%{_datadir}/%{name} && for f in *-%{version}*; do ln -sf ${f} `echo $f| sed  "s|-%{version}||g"`; done)

# plans
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}/plans
install -m 644 plans/jetty-plan.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/plans
install -m 644 plans/tomcat-plan.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/plans

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ejb
cp -pr modules/ejb/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ejb
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/streamer
cp -pr modules/streamer/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/streamer
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/web
cp -pr modules/web/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/web
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/wsappclient
cp -pr modules/wsappclient/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/wsappclient
ln -sf %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} #ghost

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files 
%defattr(0644,root,root,0755)
%doc {LICENSE.txt,README,README.jboss}
%{_javadir}/%{name}
%{_datadir}/%{name}
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/ejb-%{version}.jar.*
%attr(-,root,root) %{_libdir}/gcj/%{name}/streamer-%{version}.jar.*
%attr(-,root,root) %{_libdir}/gcj/%{name}/wsappclient-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog
* Mon Nov 27 2006 Ralph Apel <r.apel at r-apel.de> 0:1.1-1jpp
- First release 
- Add post/postun Requires for javadoc
- Add gcj_support option
